document.body.textContent = 'This is a content script in action. Click on the buttons and look at the global JS console.';

function addButton(label, handleClick) {
    var but = document.createElement('button');
    but.style.display = 'block';
    but.textContent = label;
    but.onclick = function(event) {
        event.preventDefault();
        handleClick();
    };
    document.body.appendChild(but);
}

function log(msg) {
    console.log(msg);
    document.body.appendChild(document.createElement('div')).textContent = msg;
}

var port;

addButton('runtime.connect()', () => {
    const name = new Date().toString();
    log(`[CS] ${name} opening port`);

    port = chrome.runtime.connect({name});
    port.onMessage.addListener(msg => {
        log(`[CS] ${name} Received message: ${msg}`);
    });
    port.onDisconnect.addListener(() => {
        log(`[CS] ${name} port disconnected: ${port.error}`);
    });
});

addButton('port.postMessage()', () => {
    port.postMessage('message from content script');
});

addButton('port.disconnect()', () => {
    port.disconnect();
    port = null;
});
